namespace foo.bar;

context MyModel {

  // unexisting table
  entity Table0 {
    key id : Integer;
    someText : String(100);
  }

}

context ext {

  // Table without parameters used with plain names
  // The table definition is in db/src/existing_tab1.hdbtable
  @cds.persistence.exists
  entity Tab1 {
    key id : Integer;
    some_text : String(100);
  }

  // Table without parameters used with quoted table name and plain column names
  // The table definition is in db/src/existing_tab2.hdbtable
  @cds.persistence.exists
  entity Tab2 {
    key id : Integer;
    some_text : String(100);
  }

  // Table without parameters used with quoted names
  // The table definition is in db/src/existing_tab3.hdbtable
  @cds.persistence.exists
  entity Tab3 {
    key id : Integer;
    some_text : String(100);
  }

  // View with parameters used with plain names
  // The view definition is in db/src/existing_view1.hdbview
  @cds.persistence.exists
  entity View1 (PARAM : String(10)) {
    key id : Integer;
    some_text : String(100);
  }

  // View with parameters used with quoted names
  // The view definition is in db/src/existing_view2.hdbview
  @cds.persistence.exists
  entity View2 (PARAM : String(10)) {
    key id : Integer;
    some_text : String(100);
  }

  // Table function without parameters used with plain names
  // The function definition is in db/src/existing_func1.hdbfunction
  @cds.persistence.exists
  entity Func1 {
    key id : Integer;
    some_text : String(100);
  }

  // Table function with parameters used with plain names
  // The function definition is in db/src/existing_func2.hdbfunction
  @cds.persistence.exists
  entity Func2 (PARAM : String(10)) {
    key id : Integer;
    some_text : String(100);
  }

  // Calculation view without parameters used with plain names
  // The calculation view source is in db/src/cv1.hdbcalculationview
  @cds.persistence.exists
  entity CV1 {
    key id : Integer;
    some_text : String(100);
  }

  // Calculation view with parameters used with plain names
  // The calculation view source is in db/src/cv2.hdbcalculationview
  @cds.persistence.exists
  entity CV2 (PARAM : String(10)) {
    key id : Integer;
    some_text : String(100);
    ca : Integer;
  }

  // Calculation view with parameters used with quoted names
  // The calculation view source is in db/src/cv3.hdbcalculationview
  @cds.persistence.exists
  entity CV3 (PARAM : String(10)) {
    key id : Integer;
    some_text : String(100);
    ca : Integer;
  }

}
